local frameavmi = CreateFrame("FRAME"); 
frameavmi:RegisterEvent("ADDON_LOADED"); 
frameavmi:RegisterEvent("PLAYER_LOGOUT"); 
frameavmi:RegisterEvent("PLAYER_REGEN_DISABLED");
frameavmi:RegisterEvent("PLAYER_REGEN_ENABLED");
frameavmi:RegisterEvent("COMBAT_RATING_UPDATE");
frameavmi:RegisterEvent("UNIT_RESISTANCES");
frameavmi:RegisterEvent("UNIT_AURA");

local incombat = 0
local preav = 0
local prebl = 0
local prectc = 0
local missbro = 5
if UnitRace("player") == "Night Elf" then missbro = 7 end
local ctcbro = GetDodgeChance()+GetParryChance()+GetBlockChance()+missbro
local avoidbro = GetDodgeChance()+GetParryChance()+missbro
local blockbro = GetBlockChance()
local blockamt = GetShieldBlock()

function frameavmi:OnEvent(event, arg1)
  if event == "ADDON_LOADED" and arg1 == "AvMiCheck" then
    if showhide == nil then showhide = 1
    elseif showhide == 0 then CTCFrame:Hide() end
  elseif event == "PLAYER_LOGOUT" then
    if CTCFrame:IsShown() then showhide = 1
    else showhide = 0
    end
  elseif event == "PLAYER_REGEN_DISABLED" then 
    preav = GetDodgeChance()+GetParryChance()+missbro
    prebl = GetBlockChance()
    prectc = preav+prebl
    incombat = 2
  elseif event == "PLAYER_REGEN_ENABLED" then incombat = 0
    ClassSort(avoidbro, blockbro, blockamt, incombat)
  elseif event == "COMBAT_RATING_UPDATE" or "UNIT_RESISTANCES" or "UNIT_AURA" then
    ctcbro = GetDodgeChance()+GetParryChance()+GetBlockChance()+missbro
    avoidbro = GetDodgeChance()+GetParryChance()+missbro
    blockbro = GetBlockChance()
    blockamt = GetShieldBlock()
    ClassSort(avoidbro, blockbro, blockamt, incombat)
  end
end
frameavmi:SetScript("OnEvent", frameavmi.OnEvent);


function NumToPercent(num, lvl)
  local Returnbro = 0
  if lvl > 79 then Returnbro =  num/(num+lvl*2167.5-158167.5)
  elseif UnitLevel("player") > 59 then Returnbro = num/(num-22167.5+467.5*UnitLevel("player"))
  else Returnbro = num/(num+400+85*UnitLevel("player"))
  end
  return Returnbro
end

function Main()

 
  ClassSort(avoidbro, blockbro, blockamt, incombat)
end

function ClassSort(avoidbro, blockbro, blockamt, incombat)
      local baseArmor, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
      baseArmor = NumToPercent(baseArmor, UnitLevel("player"))*100
      effectiveArmor = NumToPercent(effectiveArmor, UnitLevel("player"))*100
      armor = NumToPercent(armor, UnitLevel("player"))*100
      posBuff = NumToPercent(posBuff, UnitLevel("player"))*100
      negBuff = NumToPercent(negBuff, UnitLevel("player"))*100
      if effectiveArmor < baseArmor then buffbro = "|cff990000"..string.format("%.2f", effectiveArmor).."%|r ("..string.format("%.2f", baseArmor).."-"..string.format("%.2f", baseArmor-effectiveArmor)..")"
      elseif posBuff > 0 then buffbro = "|cff33FF00"..string.format("%.2f", effectiveArmor).."%|r ("..string.format("%.2f", baseArmor).."+"..string.format("%.2f", effectiveArmor-baseArmor)..")"
      else buffbro = string.format("%.2f", armor).."% (base)"
      end
      local itemslot = nil
      local itemlookup = nil
      local sSubType = nil
      local talent = nil
      local dcheck = nil
      local talent = GetPrimaryTalentTree()
      local dcheck = UnitBuff("player", "Bear Form")
      local bcheck = GetBlockChance()
      local itemslot = GetInventorySlotInfo("SecondaryHandSlot")
      local itemlookup = GetInventoryItemID("player", itemslot)
      if itemlookup ~= nil then sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(55069)
      end
      local avprint = nil
      local blprint = nil
      if incombat == 2 and preav < avoidbro then avprint = "|cff33FF00"..string.format("%.2f", avoidbro).."|r% (+"..string.format("%.2f", avoidbro-preav)..")"
      elseif incombat == 2 and preav > avoidbro then avprint = "|cff990000"..string.format("%.2f", avoidbro).."|r% (-"..string.format("%.2f", preav-avoidbro)..")"
      else avprint = string.format("%.2f", avoidbro).."%"
      end
      if incombat == 2 and prebl < blockbro then blprint = "|cff33FF00"..string.format("%.2f", blockbro).."|r% (+"..string.format("%.2f", blockbro-prebl)..")"
      elseif incombat == 2 and prebl > blockbro then blprint = "|cff990000"..string.format("%.2f", blockbro).."|r% (-"..string.format("%.2f", prebl-blockbro)..")"
      else blprint = string.format("%.2f", blockbro).."%"
      end
      if incombat == 2 and prectc < ctcbro then ctcprint = "|cff33FF00"..string.format("%.2f", ctcbro).."|r% (+"..string.format("%.2f", ctcbro-prectc)..")"
      elseif incombat == 2 and prectc > ctcbro then ctcprint = "|cff990000"..string.format("%.2f", ctcbro).."|r% (-"..string.format("%.2f", prectc-ctcbro)..")"
      else ctcprint = string.format("%.2f", ctcbro).."%"
      end
      local pclasst, pclass = UnitClass("player")
      if pclass == "PALADIN" and talent == 2 and sSubType == "Shields" then CTCnumber(ctcprint, avprint, blprint, blockamt, buffbro)
      elseif pclass == "PALADIN" and talent == 2 then CTC_Text:SetText("|cff990000WARNING:\nEquip a shield!|r")
      elseif pclass == "WARRIOR" and talent == 3 and sSubType == "Shields" and UnitLevel("player") > 79 then CTCnumber2(ctcprint, avprint, blprint, avoidbro, blockbro, blockamt, buffbro)
      elseif pclass == "WARRIOR" and talent == 3 and sSubType == "Shields" then CTCnumberlow(ctcprint, avprint, blprint, blockamt, buffbro)
      elseif pclass == "WARRIOR" and talent == 3 then CTC_Text:SetText("|cff990000WARNING:\nEquip a shield!|r")
      elseif pclass == "DEATHKNIGHT" and talent == 1 then DKBub(avprint, avoidbro, buffbro)
      elseif pclass == "DRUID" and dcheck == "Bear Form" and UnitLevel("player") > 39 then DBBub(avprint, avoidbro, buffbro)
      elseif pclass == "MAGE" and UnitLevel("player") > 33 then Mage(avprint, avoidbro, buffbro)
      elseif pclass == "WARLOCK" and UnitLevel("player") > 7 then Lock(avprint, avoidbro, buffbro)
      elseif pclass == "ROGUE" and UnitLevel("player") > 8 then Rogue(avprint, avoidbro, buffbro)
      elseif sSubType == "Shields" and bcheck ~= 0 then nosettings(avprint, blprint, avoidbro, blockbro, blockamt, buffbro)
      else nosetting(avprint, avoidbro, buffbro)
      end
end

function nosettings(avp, blp, abro, bbro, bamt, bubro)
  CTC_Text:SetText("Avoid: "..avp.."\nBlock: "..blp.." ("..string.format("%.0f", bamt).."%)\nArmor: "..bubro)
end

function nosetting(avp, abro, bubro)
  CTC_Text:SetText("Avoid: "..avp.."\nArmor: "..bubro)
end

function CTCnumber(ctcp, avp, blp, bamt, bubro)
  local hs2name = UnitBuff("player", "Holy Shield")
  local starths2, durhs2 = GetSpellCooldown("Holy Shield")
  if hs2name ~= nil then hs2name = "|cff33FF00Holy Shield Active|r"
  elseif durhs2 == 0 then hs2name = "|cffFFE600Holy Shield Ready|r"
  else hs2name = "|cff990000Holy Shield on CD|r"
  end
  if UnitLevel("player") > 48 then CTC_Text:SetText(hs2name.."\nYour CTC is: "..ctcp.."\nAvoid: "..avp.."\nBlock: "..blp.." ("..string.format("%.0f", bamt).."%)\nArmor: "..bubro)
  else CTC_Text:SetText("Your CTC is: "..ctcp.."\nAvoid: "..avp.."\nBlock: "..blp.." ("..string.format("%.0f", bamt).."%)\nArmor: "..bubro)
  end
end

function CTCnumber2(ctcp, avp, blp, abro, bbro, bamt, bubro)
  local ctcitbro = abro+bbro
  local cbprint = 0
  local sb2name = UnitBuff("player", "Shield Block")
  local startsb2, dursb2 = GetSpellCooldown("Shield Block")
  if sb2name ~= nil then sb2name = "|cff33FF00Shield Block Active|r"
  elseif dursb2 == 0 then sb2name = "|cffFFE600Shield Block Ready|r"
  else sb2name = "|cff990000Shield Block on CD|r"
  end
  critblock = GetMastery()*1.5
  if sb2name ~= nil and ctcitbro > 102.4 then 
    if ctcitbro >= 127.4 then cbprint=critblock+25 ctcitbro=ctcitbro-25
    else cbprint=critblock+ctcitbro-102.4 ctcitbro=102.4
    end
  else cbprint = critblock
  end
  cbprint = string.format("%.2f", cbprint)
  CTC_Text:SetText(sb2name.."\nYour CTC is: "..ctcp.."\nAvoid: "..avp.."\nBlock: "..blp.." ("..string.format("%.0f", bamt).."%)\n"..cbprint.."% Crit Block ("..string.format("%.0f", bamt*2).."%)\nArmor: "..bubro)
end

function CTCnumberlow(ctcp, avp, blp, bamt, bubro)
  local sb2name = UnitBuff("player", "Shield Block")
  local startsb2, dursb2 = GetSpellCooldown("Shield Block")
  if sb2name ~= nil then sb2name = "|cff33FF00Shield Block Active|r"
  elseif dursb2 == 0 then sb2name = "|cffFFE600Shield Block Ready|r"
  else sb2name = "|cff990000Shield Block on CD|r"
  end
  if UnitLevel("player") > 27 then CTC_Text:SetText(sb2name.."\nYour CTC is: "..ctcp.."\nAvoid: "..avp.."\nBlock: "..blp.." ("..string.format("%.0f", bamt).."%)\nArmor: "..bubro)
  else CTC_Text:SetText("Your CTC is: "..ctcp.."\nAvoid: "..avp.."\nBlock: "..blp.." ("..string.format("%.0f", bamt).."%)\nArmor: "..bubro)
  end
end

function DKBub(avp, abro, bubro)
  local bsname = UnitBuff("player", "Blood Shield")
  if bsname == nil then bsname = "|cff990000Blood Shield Not Up|r"
  else bsname = "|cff33FF00Blood Shield Up|r"
  end
  local bs2name = UnitBuff("player", "Bone Shield")
  local startbs2, durbs2 = GetSpellCooldown("Bone Shield")
  if bs2name ~= nil then bs2name = "|cff33FF00Bone Shield Active|r"
  elseif durbs2 == 0 then bs2name = "|cffFFE600Bone Shield Ready|r"
  else bs2name = "|cff990000Bone Shield on CD|r"
  end
  if UnitLevel("player") > 79 then CTC_Text:SetText(bsname.."\n"..bs2name.."\nAvoid: "..avp.."\nArmor: "..bubro)
  else CTC_Text:SetText(bs2name.."\nAvoid: "..avp.."\nArmor: "..bubro)
  end
end

function DBBub(avp, abro, bubro)
  local sdname = UnitBuff("player", "Savage Defense")
  if sdname == nil then sdname = "|cff990000Savage Defense Not Up|r"
  else sdname = "|cff33FF00Savage Defense Up|r"
  end
  if UnitLevel("player") > 39 then CTC_Text:SetText(sdname.."\nAvoid: "..avp.."\nArmor: "..bubro)
  else CTC_Text:SetText("Avoid: "..avp.."\nArmor: "..bubro)
  end
end

function Mage(avp, abro, bubro)
  local magebro = nil
  if UnitBuff("player", "Molten Armor") ~= nil then magebro = "|cff33FF00Molten Armor Active|r"
  elseif UnitBuff("player", "Frost Armor") ~= nil then magebro = "|cff33FF00Frost Armor Active|r"
  elseif UnitBuff("player", "Mage Armor") ~= nil then magebro = "|cff33FF00Mage Armor Active|r"
  else magebro = "|cff990000No Armor Active|r"
  end
  CTC_Text:SetText(magebro.."\nAvoid: "..avp.."\nArmor: "..bubro)
end

function Lock(avp, abro, bubro)
  local lockbro = nil
  if UnitBuff("player", "Demon Armor") ~= nil then lockbro = "|cff33FF00Demon Armor Active|r"
  elseif UnitBuff("player", "Fel Armor") ~= nil then lockbro = "|cff33FF00Fel Armor Active|r"
  else lockbro = "|cff990000No Armor Active|r"
  end
  CTC_Text:SetText(lockbro.."\nAvoid: "..avp.."\nArmor: "..bubro)
end

function Rogue(avp, abro, bubro)
  local robro = nil
  local startro, durro = GetSpellCooldown("Evasion")
  if UnitBuff("player", "Evasion") ~= nil then robro = "|cff33FF00Evasion Active|r"
  elseif durro == 0 then robro = "|cffFFE600Evasion Ready|r"
  else robro = "|cff990000Evasion on CD|r"
  end
  local robro2 = nil
  local startro2, durro2 = GetSpellCooldown("Combat Readiness")
  if UnitBuff("player", "Copmbat Readiness") ~= nil then robro = "|cff33FF00Combat Readiness Active|r"
  elseif durro2 == 0 then robro2 = "|cffFFE600Combat Readiness Ready|r"
  else robro2 = "|cff990000Combat Readiness on CD|r"
  end
  if UnitLevel("player") > 80 then CTC_Text:SetText(robro.."\n"..robro2.."\nAvoid: "..avp.."\nArmor: "..bubro)
  else CTC_Text:SetText(robro.."\nAvoid: "..avp.."\nArmor: "..bubro)
  end
end



SLASH_AVMICHECK1 = '/avmi'
function SlashCmdList.AVMICHECK(msg)
  if msg == 'reset' then print("AvMiCheck: Resetting...") ClassSort()
  elseif msg == 'hide' and CTCFrame:IsShown() then print("AvMiCheck: Hiding...") CTCFrame:Hide()
  elseif msg == 'hide' then print("AvMiCheck: Frame already hidden.")
  elseif msg == 'show' and CTCFrame:IsShown() == nil then print("AvMiCheck: Showing...") CTCFrame:Show()
  elseif msg == 'show' then print("AvMiCheck: Frame already showing.")
  elseif msg == 'ctc' then print("AVMiCheck: Combat Table Coverage (CTC) is the percent chance you will either block, parry, be missed, or dodge an attack.  Having your CTC at 102.4% means all incoming melee will either be dodged, parried, missed, or blocked, greatly reducing spikes in damage taken.  This is of importance to paladin and warrior tanks.")
  elseif msg == 'credit' or msg == 'credits' then print("AvMiCheck: Avoidance/Mitigation Check (AvMiCheck) v1.3.1 created by e42randy.  Contact: admin@e42randy.com or ingame (Bidoof on Blackwater Raiders)")
  else print("AvMiCheck: Commands") print("AvMiCheck: /avmi - Displays Commands") print("AvMiCheck: /avmi credits - Credits for AvMiCheck") print("AvMiCheck: /avmi ctc - Info about CTC") print("AvMiCheck: /avmi reset - Resets frame in case of error") print("AvMiCheck: /avmi (show/hide) - Show/Hide AvMiCheck frame")
  end
end